/** INCLUDES *******************************************************/
#include "mscext.h"
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "Freq_DAC.h"

/** V A R I A B L E S ********************************************************/
#pragma udata
volatile DWORD_VAL AutoHoldFreq;

volatile WORD_VAL ActualFreq;
volatile DWORD_VAL FreqError;

/** D E C L A R A T I O N S **************************************************/
#pragma code

void InitFreqDAC(void)
{
	// DATA = RA0, SYNC = RA1, SCLK = RA2
	TRISA &= 0xF8;//0b11111000; // RA0, RA1, RA2 outputs
	LATA |= 0x07;//0b00000111;  // RA0-RA2 = 1

	ActualFreq.Val = 0;
	AutoHoldFreq.Val = 0;
}

void SetFreqDAC(WORD_VAL freq)
{
	char i;
	LATAbits.LATA2 = 0;	// CLK Low
	LATAbits.LATA1 = 0;	// SYNC Low

#ifdef __18CXX
	 _asm NOP NOP _endasm
#endif

	// write PD1 and PD0
	for (i = 0; i < 8; i++)
	{
		LATAbits.LATA2 = 1;	// Rising edge
		LATAbits.LATA0 = 0;
		LATAbits.LATA2 = 0;	// Falling edge
	}

	// write level data
	for (i = 0; i < 16; i++)
	{
		LATAbits.LATA2 = 1;	// Rising edge
		LATAbits.LATA0 = freq.bits.b15;//freq.byte1.b7;
		freq.Val *= 2;	// rotate left
		LATAbits.LATA2 = 0;	// Falling edge
	}

#ifdef __18CXX
	 _asm NOP NOP _endasm
#endif

	LATAbits.LATA1 = 1;	// SYNC High
	LATAbits.LATA2 = 1;	// CLK High

}

void FreqDAC_AutoHoldFreq(DWORD_VAL measured)
{
	if (AutoHoldFreq.Val != 0x00)			// AutoHold Functionality
	{
		FreqError.Val = AutoHoldFreq.Val - measured.Val;
		ActualFreq.Val -= (FreqError.Val >> 2);
		SetFreqDAC(ActualFreq);		// Set new freq
	}
}
